;*************************************************************************
;** MMU Configuration file                                              **
;**                                                                     **
;** this file is read on startup by the mmu.library and used to modify  **
;** the pre-calculated or scanned MMU table                             **
;**                                                                     **
;**  1999 THOR Software, Thomas Richter                                **
;*************************************************************************



; the current version of the MMU library knows four commands that can
; be used in this file:
; CLEARTTX clears all or parts of the transparent translation registers
; ADDMEM   adds memory to the exec free list pool. BE WARNED, this command
;          does NOT modify the MMU tables, this must be done manually with
;          SETCACHEMODE
; SETCACHEMODE  defines the MMU tables.
; DESCRIPTORCACHEINHIBIT defines whether the data cache should be disabled
; for the MMU descriptors. It's usually OFF meaning the cache will remain
; enabled. This is fine for the mmu.library, but certain hacks might require
; an ON argument here. Note that this means more work for the library.


ClearTTx        ;ignore all TTX registers if any. We don't need them

;DescriptorCacheInhibit ON     ;make access to MMU descriptors cache inhibited


;Board specific setup follows here,
;generated by ScanToConfig 1.00  1999 THOR-Software

;General memory setup follows.
;The following lines are a compatibility cludge for some P5 boards
;which enable the MMU prior to the 68040/68060 library and leave
;the memory in CACHEINHIBIT state. You may remove the following
;lines on all other machines most likely.

SetCacheMode from 0x76000000 size 0x03F80000 Copyback
SetCacheMode from 0x00200000 size 0x00800000 Copyback
SetCacheMode from 0x00000000 size 0x00200000 CacheInhibit NonSerial Imprecise

;Memory setup end.


;In case you don't run the V40 68040 resp. 68060.library
;the following line will speed up the chip memory. It is
;not required otherwise.
SetCacheMode 0x1000 Size 0x1FF000 CacheInhibit Imprecise NonSerial

SetCacheMode 0x200000 Size 0x800000 CopyBack Valid IOSpace

SetCacheMode 0xC00000 Size 0x180000 CacheInhibit Imprecise NonSerial Valid

SetCacheMode 0xE90000 Size 0x20000 CacheInhibit Valid IOSpace

SetCacheMode 0xEB0000 Size 0x50000 CacheInhibit Valid IOSpace

SetCacheMode 0xF00000 Size 0x21000 CacheInhibit Valid IOSpace

;The following memory region should be left blank
;according to the CBM design rules. It isn't...
SetCacheMode 0xF21000 Size 0x5F000 CacheInhibit Valid IOSpace

SetCacheMode 0x76000000 Size 0x14000 CopyBack Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x76000000 Size 0x14000 CopyBack  Valid

SetCacheMode 0x76014000 Size 0x2000 CacheInhibit Imprecise NonSerial Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x76014000 Size 0x2000 CacheInhibit Imprecise NonSerial  Valid

SetCacheMode 0x76016000 Size 0x52000 CopyBack Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x76016000 Size 0x52000 CopyBack  Valid

SetCacheMode 0x76068000 Size 0x3000 CacheInhibit Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x76068000 Size 0x3000 CacheInhibit  Valid

SetCacheMode 0x7606B000 Size 0x3F15000 CopyBack Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x7606B000 Size 0x3F15000 CopyBack  Valid

SetCacheMode 0x79F80000 Size 0x80000 CacheInhibit Valid IOSpace

;If you don't own a PPC, you may remove the next line:
SetCacheMode 0x79F80000 Size 0x80000 CacheInhibit  Valid

;The following memory region should be left blank
;according to the CBM design rules. It isn't...
SetCacheMode 0xFFF00000 Size 0x80000 CacheInhibit Valid IOSpace

;The following memory region should be left blank
;according to the CBM design rules. It isn't...
SetCacheMode 0xFFF80000 Size 0x78000 CacheInhibit Valid IOSpace


;Several P5 boards build a private MMU setup on boot
;using a kludge called the BOOT-MMU-Port. To run this
;kludge, the following external command is run from
;LIBS:mmu/ as all other external commands
ScanMMUPort
;SetCacheMode FROM 0xFFFF8000 SIZE 0x00008000 VALID CACHEINHIBIT

